<?php
/**
 * Portal System v6.0
 * Copyright (c) 2001-2008 John Briggs
 * The XMB Group
 * http://xmbforum.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/

define('X_SCRIPT', 'install.php');

require 'header.php';

@set_time_limit(300);

loadtemplates('');

eval('$css = "'.template('css').'";');
eval('echo "'.template('header').'";');

if (!X_SADMIN) {
    eval('echo stripslashes("'.template('error_nologinsession').'");');
    end_time();
    eval('echo "'.template('footer').'";');
    exit();
}

smcwcache();

$auditaction = $_SERVER['REQUEST_URI'];
$aapos = strpos($auditaction, "?");
if ($aapos !== false) {
    $auditaction = substr($auditaction, $aapos + 1);
}
$auditaction = addslashes("$onlineip|#|$auditaction");
audit($xmbuser, $auditaction, 0, 0);

// BEGIN CONFIGURATION SETTINGS
$hackname = 'Portal System v6.0'; // Hack Name
$usetemplatefile = 'yes';  // Does this hack use a template (.xmb) file?  yes or no
$templatefilename = 'portal.xmb';  // Template file name, if any is used
$checkfiles = array('include/portal.inc.php', 'lang/English.portal.php','portal.php','cp_portal.php','portal.xmb'
);  // Files that need to be uploaded
// END CONFIGURATION SETTINGS
?>
<table cellspacing="0" cellpadding="0" border="0" width="100%" height="100%" align="center">
<tr><td align="center" valign="center">

<?php
if (!isset($_POST['confirmsubmit']) && !isset($_POST['licensesubmit']) && !isset($_POST['installsubmit']) && !isset($_POST['removesubmit'])) {
    $removebutton = '';
    if (file_exists("portal.php")) {
        $removebutton = '<input type="submit" name="removesubmit" value="Uninstall" />';
    }
    ?>
    <form method="post" action="install.php">
    <table cellspacing="0" cellpadding="0" border="0" width="<?php echo $tablewidth?>" align="center">
    <tr>
    <td bgcolor="<?php echo $bordercolor?>">
    <table cellspacing="<?php echo $borderwidth?>" cellpadding="<?php echo $tablespace?>" border="0" width="100%" align="center">
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg1?>" align="center"><strong><?php echo $hackname?></strong></td>
    </tr>
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg2?>" align="center">
    Thanks for choosing to install another hack by John Briggs!<br />
    <!-- Donation code removed due to broken img link.
    If You would like to donate to John briggs to show your support for XMBMods.com modifications then please proceed below.
    <br />
    <br />
    <a href="https://www.paypal.com/xclick/business=john@xmbmods.com&amp;item_name=Support XMBMods"><img src="http://www.xmbmods.com/images/paypal.gif" alt="" border="0" /></a>
    -->
    <br /><br /><br />
    This part of the installation will create all necessary database tables and templates, insert any necessary data, and configure any necessary settings.<br /><br /><br />
    Before continuing, be sure that you have completed the instructions provided in the hack installation text file.<br /><br /><br />
    <input type="submit" name="confirmsubmit" value="Install" /> <?php echo $removebutton?>
    </td>
    </tr>
    </table>
    </td>
    </tr>
    </table>
    </form>
    <?php
}

if (isset($_POST['removesubmit'])) {
    $db->query("ALTER TABLE ".X_PREFIX."settings
        DROP portaltitle,
        DROP portalnewsfid,
        DROP portalnewsdisplays,
        DROP portalmposts,
        DROP portalhotdate,
        DROP portalhottopics,
        DROP portaldgif,
        DROP portalnewmembers,
        DROP portalrmods,
        DROP portalavatar,
        DROP portaltopmembers,
        DROP portalpostsnull,
        DROP portalstatus,
        DROP portalview
    ");

    $db->query("DROP TABLE IF EXISTS ".X_PREFIX."portal_templates");
    $db->query("DELETE FROM ".X_PREFIX."templates WHERE name LIKE 'portal_%'");
    $db->query("DELETE FROM ".X_PREFIX."templates WHERE name LIKE 'padmin_%'");
    $db->query("DELETE FROM ".X_PREFIX."templates WHERE name=''");
    ?>
    <table cellspacing="0" cellpadding="0" border="0" width="<?php echo $tablewidth?>" align="center">
    <tr>
    <td bgcolor="<?php echo $bordercolor?>">
    <table cellspacing="<?php echo $borderwidth?>" cellpadding="<?php echo $tablespace?>" border="0" width="100%" align="center">
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg1?>" align="center"><strong>Uninstall</strong></td>
    </tr>
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg2?>" align="center">
    <strong><?php echo $hackname?></strong> has been successfully removed!<br /><br /><br />
    To complete the uninstall, please delete the file <strong>install.php</strong> and <strong>portal.xmb</strong>.
    </td>
    </tr>
    </table>
    </td>
    </tr>
    </table>
    <?php
}

if (isset($_POST['confirmsubmit'])) {
    ?>
    <form method="post" action="install.php">
    <table cellspacing="0" cellpadding="0" border="0" width="<?php echo $tablewidth?>" align="center">
    <tr>
    <td bgcolor="<?php echo $bordercolor?>">
    <table cellspacing="<?php echo $borderwidth?>" cellpadding="<?php echo $tablespace?>" border="0" width="100%" align="center">
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg1?>" align="center"><strong>Important!</strong></td>
    </tr>
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg2?>" align="center">
    As with any hack, it is recommended that you back up your current database, templates, and files.<br /><br /><br />
    This safety precaution can mean the difference between a successful installation or an evening full of headaches.<br /><br /><br />
    Did you make a backup of your database and templates?<br /><br /><br />
    <input type="submit" name="licensesubmit" value="Yes"> <input type="submit" name="cancelsubmit" value="No" />
    </td>
    </tr>
    </table>
    </td>
    </tr>
    </table>
    </form>
    <?php
}

if (isset($_POST['licensesubmit'])) {
    ?>
    <form method="post" action="install.php">
    <table cellspacing="0" cellpadding="0" border="0" width="<?php echo $tablewidth?>" align="center">
    <tr>
    <td bgcolor="<?php echo $bordercolor?>">
    <table cellspacing="<?php echo $borderwidth?>" cellpadding="<?php echo $tablespace?>" border="0" width="100%" align="center">
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg1?>" align="center"><strong>License Agreement</strong></td>
    </tr>
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg2?>" align="center">
    This hack and all code contained within are released under the GPL license.<br /><br /><br />
    All copyright information, found within this hack, may not be removed for any reason and must remain visible at all times.<br /><br /><br />
    Do you agree to these terms?<br /><br /><br />
    <input type="submit" name="installsubmit" value="Agree"> <input type="submit" name="cancelsubmit" value="Disagree" />
    </td>
    </tr>
    </table>
    </td>
    </tr>
    </table>
    </form>
    <?php
}

if (isset($_POST['installsubmit'])) {
    ?>
    <form method="post" action="install.php">
    <table cellspacing="0" cellpadding="0" border="0" width="<?php echo $tablewidth?>" align="center">
    <tr>
    <td bgcolor="<?php echo $bordercolor?>">
    <table cellspacing="<?php echo $borderwidth?>" cellpadding="<?php echo $tablespace?>" border="0" width="100%" align="center">
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg1?>" align="center"><strong><?php echo $hackname?></strong></td>
    </tr>
    <tr>
    <td class="tablerow" bgcolor="<?php echo $altbg2?>" align="center">
    <?php
    for($i = 0; $i < count($checkfiles); $i++) {
        if (!file_exists($checkfiles[$i])) {
            echo '<strong>Error!</strong> The installation has been halted.<br /><br /><br />';
            echo 'The file, <strong>'.$checkfiles[$i].'</strong>, does not exist.<br /><br /><br />';
            echo 'Please upload the file and click restart to continue.<br /><br /><br />';
            echo '<input type="submit" name="cancelsubmit" value="Restart" />';
            exit;
        }
    }
    ?>
    Now installing! Please be patient as this process may take a few minutes.<br /><br /><br />
    <?php
    // BEGIN PORTAL SETTINGS
    echo "Updating table <strong>".X_PREFIX."settings</strong> and inserting any necessary data.<br /><br />";
    $db->query("ALTER TABLE ".X_PREFIX."settings ADD (
      portaltitle varchar(50) NOT NULL default 'Portal',
      portalnewsfid smallint(30) NOT NULL default '1',
      portalnewsdisplays smallint(30) NOT NULL default '5',
      portalmposts smallint(30) NOT NULL default '10',
      portalhotdate smallint(30) NOT NULL default '3',
      portalhottopics smallint(30) NOT NULL default '5',
      portaldgif varchar(50) NOT NULL default 'info.gif',
      portalnewmembers smallint(30) NOT NULL default '5',
      portalrmods smallint(30) NOT NULL default '5',
      portalavatar set('on','off') NOT NULL default 'on',
      portaltopmembers smallint(30) NOT NULL default '5',
      portalpostsnull varchar(50) NOT NULL default '',
      portalstatus set('on','off') NOT NULL default 'on',
      portalview set('on','off') NOT NULL default 'off'
    )");
    // END PORTAL SETTINGS
    // BEGIN PORTAL TEMPLATES
    echo "Creating table <strong>".X_PREFIX."portal_templates</strong> and inserting any necessary data.<br /><br />";
    $db->query("DROP TABLE IF EXISTS ".X_PREFIX."portal_templates");
    $db->query("CREATE TABLE ".X_PREFIX."portal_templates (
      id smallint(6) NOT NULL auto_increment,
      name varchar(75) NOT NULL default '',
      direction set('left','center','right') NOT NULL default '',
      status set('on','off') NOT NULL default '',
      displayorder int(50) NOT NULL default '0',
      PRIMARY KEY (id),
      KEY name (name),
      KEY displayorder (displayorder)
    )");
    // END PORTAL TEMPLATES
    // BEGIN INSERTING PORTAL TEMPLATES
    echo "Inserting <strong>".X_PREFIX."portal_templates</strong> and any necessary data.<br /><br />";
    $db->query("INSERT INTO ".X_PREFIX."portal_templates (id, name, direction, status, displayorder) VALUES ('', 'portal_main_block', 'center', 'on', '1');");
    $db->query("INSERT INTO ".X_PREFIX."portal_templates (id, name, direction, status, displayorder) VALUES ('', 'portal_main_menu', 'left', 'on', '1');");
    $db->query("INSERT INTO ".X_PREFIX."portal_templates (id, name, direction, status, displayorder) VALUES ('', 'portal_member_mood', 'right', 'on', '2');");
    $db->query("INSERT INTO ".X_PREFIX."portal_templates (id, name, direction, status, displayorder) VALUES ('', 'portal_newmember', 'left', 'on', '2');");
    $db->query("INSERT INTO ".X_PREFIX."portal_templates (id, name, direction, status, displayorder) VALUES ('', 'portal_newposts', 'left', 'on', '3');");
    $db->query("INSERT INTO ".X_PREFIX."portal_templates (id, name, direction, status, displayorder) VALUES ('', 'portal_search', 'left', 'on', '4');");
    $db->query("INSERT INTO ".X_PREFIX."portal_templates (id, name, direction, status, displayorder) VALUES ('', 'portal_top_members', 'right', 'on', '1');");
    // END INSERTING PORTAL TEMPLATES
    // BEGIN TEMPLATES
    if ($usetemplatefile == 'yes') {
        echo "Creating any necessary templates.<br /><br />";
        $db->query("DELETE FROM ".X_PREFIX."templates WHERE name LIKE 'portal_%'");
        $db->query("DELETE FROM ".X_PREFIX."templates WHERE name LIKE 'padmin_%'");
        $filesize = @filesize($templatefilename);
        $fp = @fopen($templatefilename, 'r');
        $templatesfile = @fread($fp, $filesize);
        @fclose($fp);
        $templates = explode("|#*XMB TEMPLATE FILE*#|", $templatesfile);
        while(list($key,$val) = each($templates)) {
            $template = explode("|#*XMB TEMPLATE*#|", $val);
            if (isset($template[1])) {
                $template['1'] = addslashes($template[1]);
                $db->query("INSERT INTO ".X_PREFIX."templates (id, name, template) VALUES ('', '".addslashes($template[0])."', '".addslashes($template[1])."')");
            }
        }
        $db->query("DELETE FROM ".X_PREFIX."templates WHERE name = ''");
    }
    // END TEMPLATES
    require ROOT.'include/portal.inc.php';
    $query = $db->query("SELECT devname FROM ".X_PREFIX."lang_base");
    while ($row = $db->fetch_array($query)) {
        echo "Initializing the {$row['devname']} Portal translation.<br /><br />";
        installPortalTranslation($row['devname']);
    }
    ?>
    <br />
    The installation of <strong><?php echo $hackname?></strong> is now complete!<br /><br /><br />
    Please delete files <strong>install.php</strong> and <strong>portal.xmb</strong> and click finish to continue.<br /><br /><br />
    <input type="button" onclick="location.href='cp_portal.php'" value="Finish" />
    </td>
    </tr>
    </table>
    </td>
    </tr>
    </table>
    </form>
    <?php
    @unlink("portal.xmb");
    @unlink("install.php");
}

end_time();
eval('echo "'.template('footer').'";');
?>
